--- mod_ustats/ngx_http_ustats_module.c_orig	2011-05-10 17:41:21.000000000 +0300
+++ mod_ustats/ngx_http_ustats_module.c	2012-05-17 12:02:42.000000000 +0300
@@ -715,14 +715,27 @@
 
 static ngx_int_t ngx_http_ustats_init_shm(ngx_shm_zone_t * shm_zone, void * data)
 {
-	if (data)
+    void *new_block;
+    ngx_slab_pool_t *shpool = (ngx_slab_pool_t *)shm_zone->shm.addr;
+        
+        	if (data)
 	{
 		shm_zone->data = data;
 		return NGX_OK;
 	}
 
-	memset(shm_zone->shm.addr, 0, stats_data_size);
-	shm_zone->data = (void*)1; // new_data;
+//	memset(shm_zone->shm.addr, 0, stats_data_size);
+//	shm_zone->data = (void*)1; // new_data;
+
+    new_block = ngx_slab_alloc(shpool, stats_data_size);
+    if (new_block == NULL) {
+        return NGX_ERROR;
+    }
+
+    memset(new_block, 0, stats_data_size);
+
+    shpool->data=new_block;
+    shm_zone->data = new_block; // new_data;
 
 	return NGX_OK;
 }
@@ -786,7 +799,7 @@
 	else
 		stats_data_size = size;
 
-	ngx_conf_log_error(NGX_LOG_DEBUG, cf, 0, "ustats: using %udB of shared memory", stats_data_size);
+	ngx_conf_log_error(NGX_LOG_DEBUG, cf, 0, "ustats: using %udB of shared memory", stats_data_size+ngx_pagesize*2);
 
     ngx_str_t * shm_name = NULL;
 	shm_name = ngx_palloc(cf->pool, sizeof(*shm_name));
@@ -796,7 +809,7 @@
 	if (stats_data_size == 0)
 		stats_data_size = ngx_pagesize;
 
-	stats_data = ngx_shared_memory_add(cf, shm_name, stats_data_size, &ngx_http_ustats_module);
+	stats_data = ngx_shared_memory_add(cf, shm_name, stats_data_size+ngx_pagesize*2, &ngx_http_ustats_module);
 
 	if (stats_data == NULL)
 		return NGX_CONF_ERROR;